/*
TASK:maxsqu
LANG:C++
*/
# include <cstdio>
# include <algorithm>
# define MAXN (1<<10)

using namespace std;

unsigned short data[MAXN][MAXN];
unsigned short t[MAXN*2][MAXN*2];
int n,m,k;

void readf() {
    scanf("%d %d",&n,&m);
    for ( int i=0 ; i<n ; i++ ) 
	for ( int j=0 ; j<m ; j++ ) {
	    scanf("%hu",&data[i][j]);
	}
}

void build() {
    for ( int i=0 ; i<MAXN ; i++ ) {
	for ( int j=0 ; j<MAXN ; j++ ) {
	    t[i+MAXN-1][j+MAXN-1] = data[i][j];
	}
	for ( int j=MAXN-2 ; j>=0 ; j-- ) {
	    t[i+MAXN-1][j] = max( t[i+MAXN-1][j*2+1], t[i+MAXN-1][j*2+2]);
	}
    }
    for ( int i=MAXN-2 ; i>=0 ; i-- ) {
	for ( int j=0 ; j<MAXN*2 ; j++ ) {
	    t[i][j] = max( t[i*2+1][j], t[i*2+2][j] );
	}
    }

}

int aa,bb;

int ask1(int i1, int p, int a, int b, int x, int y) {
    if ( a==x && b==y ) return t[i1][p];
    int mid = (x+y)/2;
    int res=0;
    if ( b<=mid ) {
	res = max(res,ask1(i1,p*2+1,a,b,x,mid));
    } else if ( a>mid ) {
	res = max(res,ask1(i1,p*2+2,a,b,mid+1,y));
    } else {
	res = max(ask1(i1,p*2+1,a,mid,x,mid), ask1(i1,p*2+2,mid+1,b,mid+1,y));
    }
    return res;
}
int ask(int p, int a, int b, int x, int y) {
    if ( a==x && b==y ) return ask1(p,0,aa,bb,0,MAXN-1);
    int mid = (x+y)/2;
    int res=0;
    if ( b<=mid ) {
	res = max(res,ask(p*2+1,a,b,x,mid));
    } else if ( a>mid ) {
	res = max(res,ask(p*2+2,a,b,mid+1,y));
    } else {
	res = max(ask(p*2+1,a,mid,x,mid), ask(p*2+2,mid+1,b,mid+1,y));
    }
    return res;
}


void answer() {
    scanf("%d",&k);
    int a,b,s;
    while ( k ) {
	scanf("%d %d %d",&a,&b,&s);
	aa = b;
	bb = b+s-1;
	printf("%d\n",ask(0,a,a+s-1,0,MAXN-1));
	
	k--;
    }

}

int main() {
    readf();

    build();
    
    answer();

    return 0;
}
